unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus;

type
  TGrabSubClass = class(TObject)
  protected
  private
    FTargetCtrl : TControl; // ׷  Ʈ.
    FMsgRcvHwnd : THandle;
    FSelected   : Boolean;
    FOrgWndProc : TWndMethod;
    procedure NewWndProc(var Message : TMessage);
    procedure SetSelected(Value : Boolean);
    procedure SetBoundsRect(Value : TRect);
    function GetBoundsRect : TRect;
  public
    Constructor Create(Control : TControl; MsgRcvHwnd : THandle); dynamic;
    Destructor Destroy; override;
    property Selected : Boolean read FSelected write SetSelected;
    property BoundsRect : TRect read GetBoundsRect write SetBoundsRect;
  end;

  // ׷ ڵ.  ű .
  TGHType = (ghTT, ghBB, ghLL, ghRR, ghTL, ghTR, ghBL, ghBR);

  //  Ŭ ±׿ ޽   ڵ  ش.
  TGrabHandle = class(TCustomPanel)
  protected
    FTargetCtrl : TControl;
    FOldRect    : TRect;  // Ʈ ũ.
    FStartPos   : TPoint; // 巡 ۵  ġ.
    //FOldPos     : TPoint; //
  private
    FGHType     : TGHType;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Lock(Control : TControl);
    procedure ReLock;
    procedure UnLock;
    property GHType : TGHType read FGHType write FGHType;
  end;

  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button5: TButton;
    ListBox1: TListBox;
    Button4: TButton;
    Button6: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
    GrabSubClassList : TStringList;

    GrabHandleTT,
    GrabHandleBB,
    GrabHandleLL,
    GrabHandleRR,

    GrabHandleTR,
    GrabHandleTL,
    GrabHandleBR,
    GrabHandleBL  : TGrabHandle;

    // Ʈ ̵/  .
    StartPos       : TPoint;    // 콺  ǥ Ƶδ .

    //   Ʈ ̵ ϴ .
    OldRect        : TRect;     // 콺  Ʈ ǥ ϴ .
    MSelectControl : TControl;  // 콺  Ʈ ӽ÷ ϴ .
    MouseDowned    : Boolean;   // 콺 ȴ .

    ShiftMouseDowned : Boolean; // Ʈ Ű  ý.
    MultiSelControl  : TControl;//  ̵  ű Ʈ.
    MultiSelDowned   : Boolean; //  õǾ ̵  .
    MultiSelChanged  : Boolean; // ̵ Ͼ.
    OldPos           : TPoint;  //  ̵, Ʈ ý ǥ .

    CtrlSelControl : TWinControl; // Ʈ Ű     ̽ Ʈ.
    CtrlSelDowned  : Boolean;     // Ʈ Ű   ߴ .
    CtrlSelChanged : Boolean;

    FOldProc: Pointer;
    FNewProc: Pointer;
    procedure NewWndProc( var Message: TMessage );

    procedure OnWMUser19125(var Message: TMessage); message WM_USER+19125;
    procedure OnWMUser19126(var Message: TMessage); message WM_USER+19126;
    procedure OnWMUser19127(var Message: TMessage); message WM_USER+19127;
    procedure OnWMUser19128(var Message: TMessage); message WM_USER+19128;
    procedure OnWMUser19129(var Message: TMessage); message WM_USER+19129;
    procedure OnWMUser19130(var Message: TMessage); message WM_USER+19130;
  private
    FOldFormPaint : TNotifyEvent;
    procedure FormPaint(Sender: TObject);
    function SelCtrlIsOver2 : Boolean; // õ Ʈ   ̻ .
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

uses Unit1;

Const
  SnapX = 8;
  SnapY = 8;

(*----------------------------------------------------------------------------*)
//  Լ..
(*----------------------------------------------------------------------------*)

// θ Ʈ ڵ Ѵ.
function GetOwnerWnd(pParent : THandle) : THandle;
begin
  if (GetParent(pParent) = 0) then
     Result := pParent
  else
    Result := GetOwnerWnd(GetParent(pParent));
end;

// Ʈ ŭ 콺 ǥ Ѵ.
procedure ClipControlCursor(WinControl : TWinControl);
var
  Rect1, Rect2 : TRect;
  MenuExists : Boolean;
begin
  // Ŭ̾Ʈ  ´.
  Windows.GetClientRect(WinControl.Handle, Rect1);
  Windows.GetWindowRect(WinControl.Handle, Rect2);
  SetRect(Rect1,
    Rect1.Left + Rect2.Left,
    Rect1.Top + Rect2.Top,
    Rect1.Right + Rect2.Left,
    Rect1.Bottom + Rect2.Top
  );

  if WinControl is TForm then //  ..
    MenuExists := TForm(WinControl).Menu <> nil
  else
    MenuExists := false;

  SetRect(Rect2, 0, 0, 0, 0);
  AdjustWindowRectEx(
    Rect2, GetWindowLong(WinControl.Handle, GWL_STYLE),
    MenuExists, GetWindowLong(WinControl.Handle, GWL_EXSTYLE)
  );

  SetRect(Rect1,
    Rect1.Left - Rect2.Left,
    Rect1.Top - Rect2.Top,
    Rect1.Right - Rect2.Left,// - Rect2.Right,
    Rect1.Bottom - Rect2.Top// - Rect2.Bottom
  );

  ClipCursor(@Rect1);

end;

// ־ Ʈѿ 簢 ׸. XOR̸  Gray
procedure RectToCtrl(Ctrl: TWinControl; R: TRect; W: Integer; PSt : TPenStyle);
var
  Rgn      : HRGN;  // Ŭ  
  ClipRect : TRect; // Ŭ   ǥ.
  CortRect : TRect; //  簢.
  MenuExists : Boolean;
begin
  // ׷  Ŭ̾Ʈ  ϰ..
  Windows.GetClientRect(Ctrl.Handle, ClipRect);

  // Ȯ Ŭ̾Ʈ     ǥ Ѵ.
  if Ctrl is TForm then //  ..
    MenuExists := TForm(Ctrl).Menu <> nil
  else
    MenuExists := false;
  SetRect(CortRect, 0, 0, 0, 0);
  AdjustWindowRectEx(
    CortRect, GetWindowLong(Ctrl.Handle, GWL_STYLE),
    MenuExists, GetWindowLong(Ctrl.Handle, GWL_EXSTYLE)
  );

  // ׷ 簢  .
  OffsetRect(R, -CortRect.Left, -CortRect.Top);

  // Ŭ  .
  SetRect(ClipRect,
    ClipRect.Left - CortRect.Left,
    ClipRect.Top - CortRect.Top,
    ClipRect.Right - CortRect.Left,
    ClipRect.Bottom - CortRect.Top
  );

  with ClipRect do
    Rgn := CreateRectRgn(Left, Top, Right, Bottom);

  with TCanvas.Create do
  try
    Handle := GetWindowDC(Ctrl.Handle);

    Brush.Style := bsClear;
    Pen.Mode := pmXOR;
    Pen.Width := W;
    Pen.Style := PSt;
    Pen.Color := clGray;

    SelectClipRgn(Handle, Rgn);
    Rectangle(R);
  finally
    DeleteObject(Rgn);
    ReleaseDC(Ctrl.Handle, Handle);
    Free;
  end;
end;

(*----------------------------------------------------------------------------*)

(*----------------------------------------------------------------------------*)
// TGrabSubClass  ޼ҵ  Ÿ Ǻ.
(*----------------------------------------------------------------------------*)
type
  TMyComp = Class(TComponent);

Constructor TGrabSubClass.Create(Control : TControl; MsgRcvHwnd : THandle);
begin
  inherited Create;
  FMsgRcvHwnd := MsgRcvHwnd;
  FSelected   := False;
  if Control <> nil then
  begin
    FTargetCtrl := Control;
    TMyComp(FTargetCtrl).SetDesigning(True);
    FOrgWndProc := FTargetCtrl.WindowProc;
    FTargetCtrl.WindowProc := NewWndProc;
  end;
end;

Destructor TGrabSubClass.Destroy;
begin
  if FTargetCtrl <> nil then
  begin
    TMyComp(FTargetCtrl).SetDesigning(False);
    FTargetCtrl.WindowProc := FOrgWndProc;
    FTargetCtrl := nil;
  end;
  inherited Destroy;
end;

procedure TGrabSubClass.SetSelected(Value : Boolean);
begin
  if Value <> FSelected then
  begin
    FSelected := Value;
    FTargetCtrl.Invalidate;
  end;
end;

procedure TGrabSubClass.SetBoundsRect(Value : TRect);
begin
  if FTargetCtrl <> nil then
    FTargetCtrl.BoundsRect := Value;
end;

function TGrabSubClass.GetBoundsRect : TRect;
begin
  if FTargetCtrl <> nil then
    Result := FTargetCtrl.BoundsRect;
end;

procedure TGrabSubClass.NewWndProc(var Message : TMessage);
var
  PS          : TPaintStruct;
  DC          : HDC;
  DrawRect    : TRect;
//  AdjustRect  : TRect;
  Pt          : TPoint;
  TempControl : TControl;
begin
  with Message do
  Case Msg of
    // Ŀ .
    WM_SETFOCUS : Exit;

    // Ŭ...   Ʈ̸,  ġ Ʈ ã ѱ.
    WM_LBUTTONDBLCLK :
    begin
      Pt := Point(LoWord(lParam), HiWord(lParam));

      TempControl := nil;

      if FTargetCtrl is TWinControl then
        TempControl := TWinControl(FTargetCtrl).ControlAtPos(Pt, True, False);

      if TempControl = nil then
        TempControl := FTargetCtrl
      else
        Pt := TempControl.ScreenToClient(FTargetCtrl.ClientToScreen(Pt));

      SendMessage(
        FMsgRcvHwnd,
        WM_USER+19126,
        Cardinal(Pointer(@TempControl)),
        Cardinal(Pointer(@Pt))
      );

      TempControl := nil;
      Exit;
    end;

    // 콺  ...   Ʈ̸,  ġ Ʈ ã ѱ.
    WM_LBUTTONDOWN:
    begin
      Pt := Point(LoWord(lParam), HiWord(lParam));

      TempControl := nil;

      if FTargetCtrl is TWinControl then
        TempControl := TWinControl(FTargetCtrl).ControlAtPos(Pt, True, False);

      if TempControl = nil then
        TempControl := FTargetCtrl
      else
        Pt := TempControl.ScreenToClient(FTargetCtrl.ClientToScreen(Pt));

      SendMessage(
        FMsgRcvHwnd,
        WM_USER+19127,
        Cardinal(Pointer(@TempControl)),
        Cardinal(Pointer(@Pt))
      );

      TempControl := nil;
      Exit;
    end;

    WM_MOUSEMOVE :
    if FTargetCtrl is TWinControl then
    begin
      SendMessage(FMsgRcvHwnd, WM_USER+19128, Cardinal(wParam and MK_LBUTTON <> 0), 0);
    end;

    WM_LBUTTONUP :
    begin
      ClipCursor(nil);
      if FTargetCtrl is TWinControl then
        SendMessage(FMsgRcvHwnd, WM_USER+19129, 0, 0);
    end;

    WM_WINDOWPOSCHANGED :
    begin
      PostMessage(FMsgRcvHwnd, WM_USER+19130, $AAAA, 0);
      FTargetCtrl.Invalidate;
    end;

    WM_KEYDOWN :
    begin
      PostMessage(FMsgRcvHwnd, WM_USER+19125, wParam, lParam);
      Exit;
    end;

  end;

  FOrgWndProc(Message);

  with Message do
  Case Msg of
    // Ʈ FSelected ϴ ޽.
    WM_USER+19131 :
    Case wParam of
      $AAAA : Result := Cardinal(Selected);
      $BBBB : Selected := Boolean(lParam);
    end;

    // ƼƮ  õ  ֱ.
    WM_PAINT :
    if FSelected then
    begin
      if FTargetCtrl is TWinControl then
      begin
        BeginPaint(TWinControl(FTargetCtrl).Handle, PS);
        //DC := GetWindowDC(TWinControl(FTargetCtrl).Handle);
        DC := GetDC(TWinControl(FTargetCtrl).Handle);
        with TCanvas.Create do
        try
          Handle := DC;
          Windows.GetClientRect(TWinControl(FTargetCtrl).Handle, DrawRect);
          {
          SetRect(AdjustRect, 0, 0, 0, 0);
          AdjustWindowRectEx(
            AdjustRect, GetWindowLong(TWinControl(FTargetCtrl).Handle, GWL_STYLE),
            False, GetWindowLong(TWinControl(FTargetCtrl).Handle, GWL_EXSTYLE)
          );

          SetRect(DrawRect,
            DrawRect.Left - AdjustRect.Left,
            DrawRect.Top - AdjustRect.Top,
            DrawRect.Right - AdjustRect.Left,
            DrawRect.Bottom - AdjustRect.Top
          );
          }
          Brush.Color := clGray;
          Brush.Style := bsSolid;
          Pen.Color := clGray;
          Rectangle(Bounds(DrawRect.Left, DrawRect.Top, 5, 5));
          Rectangle(Bounds(DrawRect.Right -5, DrawRect.Top, 5, 5));
          Rectangle(Bounds(DrawRect.Right -5, DrawRect.Bottom -5, 5, 5));
          Rectangle(Bounds(DrawRect.Left, DrawRect.Bottom -5, 5, 5));
        finally
          ReleaseDC(TWinControl(FTargetCtrl).Handle, Handle);
          EndPaint(TWinControl(FTargetCtrl).Handle, PS);
          Free;
        end;
      end
      else
      begin
        //BeginPaint(TWinControl(FTargetCtrl.GetParentComponent).Handle, PS);
        //DC := GetDC(TWinControl(FTargetCtrl.GetParentComponent).Handle);
        BeginPaint(FTargetCtrl.Parent.Handle, PS);
        DC := GetDC(FTargetCtrl.Parent.Handle);
        with TCanvas.Create do
        try
          DrawRect := FTargetCtrl.BoundsRect;
          Handle := DC;
          Brush.Color := clGray;
          Brush.Style := bsSolid;
          Pen.Color := clGray;
          Rectangle(Bounds(DrawRect.Left, DrawRect.Top, 5, 5));
          Rectangle(Bounds(DrawRect.Right -5, DrawRect.Top, 5, 5));
          Rectangle(Bounds(DrawRect.Right -5, DrawRect.Bottom -5, 5, 5));
          Rectangle(Bounds(DrawRect.Left, DrawRect.Bottom -5, 5, 5));
        finally
          //ReleaseDC(TWinControl(FTargetCtrl.GetParentComponent).Handle, Handle);
          //EndPaint(TWinControl(FTargetCtrl.GetParentComponent).Handle, PS);
          ReleaseDC(FTargetCtrl.Parent.Handle, Handle);
          EndPaint(FTargetCtrl.Parent.Handle, PS);
          Free;
        end;
      end;
    end;
  end;
end;

(*----------------------------------------------------------------------------*)

(*----------------------------------------------------------------------------*)
// TGrabHandle.
(*----------------------------------------------------------------------------*)
constructor TGrabHandle.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  BevelInner := bvNone;
  BevelOuter := bvNone;
  Color  := clBlack;
  Width  := 5;
  Height := 5;
  GHType := ghTT;
end;

destructor TGrabHandle.Destroy;
begin
  inherited Destroy;
end;

procedure TGrabHandle.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  //  콺  쿡 .
  if not (ssLeft in Shift) then Exit;

  // Ŀ  .
  ClipControlCursor(Parent);

  //  Ŀ ġ  .
  FStartPos := Point(X, Y);

  // ׷ Ʈѵ ȭ鿡  ..
  SendMessage(Tag, WM_USER+19130, $BBBB, 0);

  // 簢 ׸.
  FOldRect := FTargetCtrl.BoundsRect;
  RectToCtrl(
    FTargetCtrl.Parent,
    Rect(FOldRect.Left +1, FOldRect.Top +1, FOldRect.Right, FOldRect.Bottom),
    2,
    psSolid
  );
end;

procedure TGrabHandle.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  //  콺  쿡 .
  if not (ssLeft in Shift) then Exit;

  if (FStartPos.X - X) mod SnapX <> 0 then X := X + (FStartPos.X - X) mod SnapX;
  if (FStartPos.Y - Y) mod SnapY <> 0 then Y := Y + (FStartPos.Y - Y) mod SnapY;
  if (FStartPos.X = X) and (FStartPos.Y = Y) then Exit;

  //   
  RectToCtrl(
    FTargetCtrl.Parent,
    Rect(FOldRect.Left +1, FOldRect.Top +1, FOldRect.Right, FOldRect.Bottom),
    2,
    psSolid
  );

  Case FGHType of
    ghTT :
    begin
      FOldRect :=
        Rect(FOldRect.Left, FOldRect.Top - (FStartPos.Y - Y), FOldRect.Right, FOldRect.Bottom);
      FStartPos.Y := Y;
    end;

    ghBB :
    begin
      FOldRect :=
        Rect(FOldRect.Left, FOldRect.Top, FOldRect.Right, FOldRect.Bottom - (FStartPos.Y - Y));
      FStartPos.Y := Y;
    end;

    ghLL :
    begin
      FOldRect :=
        Rect(FOldRect.Left - (FStartPos.X - X), FOldRect.Top, FOldRect.Right, FOldRect.Bottom);
      FStartPos.X := X;
    end;

    ghRR :
    begin
      FOldRect :=
        Rect(FOldRect.Left, FOldRect.Top, FOldRect.Right - (FStartPos.X - X), FOldRect.Bottom);
      FStartPos.X := X;
    end;

    ghTL :
    begin
      FOldRect :=
        Rect(FOldRect.Left - (FStartPos.X - X), FOldRect.Top - (FStartPos.Y - Y), FOldRect.Right, FOldRect.Bottom);
      FStartPos.X := X;
      FStartPos.Y := Y;
    end;

    ghTR :
    begin
      FOldRect :=
        Rect(FOldRect.Left, FOldRect.Top - (FStartPos.Y - Y), FOldRect.Right - (FStartPos.X - X), FOldRect.Bottom);
      FStartPos.X := X;
      FStartPos.Y := Y;
    end;

    ghBL :
    begin
      FOldRect :=
        Rect(FOldRect.Left - (FStartPos.X - X), FOldRect.Top, FOldRect.Right, FOldRect.Bottom - (FStartPos.Y - Y));
      FStartPos.X := X;
      FStartPos.Y := Y;
    end;

    ghBR :
    begin
      FOldRect :=
        Rect(FOldRect.Left, FOldRect.Top, FOldRect.Right - (FStartPos.X - X), FOldRect.Bottom - (FStartPos.Y - Y));
      FStartPos.X := X;
      FStartPos.Y := Y;
    end;
  end;

  //   ׸.
  RectToCtrl(
    FTargetCtrl.Parent,
    Rect(FOldRect.Left +1, FOldRect.Top +1, FOldRect.Right, FOldRect.Bottom),
    2,
    psSolid
  );

end;

procedure TGrabHandle.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Int : Integer; // 簢   ġ̵  .
begin
  inherited;

  // 簢 ٽ   ׷  Ŀ..
  RectToCtrl(
    FTargetCtrl.Parent,
    Rect(FOldRect.Left +1, FOldRect.Top +1, FOldRect.Right, FOldRect.Bottom),
    2,
    psSolid
  );

  if FOldRect.Left > FOldRect.Right then // ¿ ǥ ٲ  ̹Ƿ...
  begin
    Int := FOldRect.Left;
    FOldRect.Left := FOldRect.Right;
    FOldRect.Right := Int;
  end;

  if FOldRect.Top > FOldRect.Bottom then //  ǥ ٲ  ̹Ƿ...
  begin
    Int := FOldRect.Top;
    FOldRect.Top := FOldRect.Bottom;
    FOldRect.Bottom := Int;
  end;

  // ũ ϱ...
  FTargetCtrl.SetBounds(
    FOldRect.Left, FOldRect.Top,
    FOldRect.Right - FOldRect.Left,
    FOldRect.Bottom - FOldRect.Top
  );

  SetRect(FOldRect, -10000, -10000, 0, 0);

  //   .
  ClipCursor(nil);

  // ׸ Ʈѵ ٽ ȭ鿡 ǥѴ.
  PostMessage(Tag, WM_USER+19130, $AAAA, 0);
end;

procedure TGrabHandle.Lock(Control : TControl);
begin
  if Control = nil then Exit;
  Case FGHType of
    ghTT :
    begin
      Left := Control.Width div 2 + Control.Left -2;
      Top := Control.Top - 2;
      Cursor := crSizeNS;
    end;

    ghBB :
    begin
      Left := Control.Width div 2 + Control.Left -2;
      Top := Control.Top + Control.Height - 3;
      Cursor := crSizeNS;
    end;

    ghLL :
    begin
      Left := Control.Left -2;
      Top := Control.Height div 2 + Control.Top -2;
      Cursor := crSizeWE;
    end;

    ghRR :
    begin
      Left := Control.Left + Control.Width -3;
      Top := Control.Height div 2 + Control.Top -3;
      Cursor := crSizeWE;
    end;

    ghTL :
    begin
      Left := Control.Left - 2;
      Top := Control.Top - 2;
      Cursor := crSizeNWSE;
    end;

    ghTR :
    begin
      Left := Control.Left + Control.Width - 3;
      Top := Control.Top - 2;
      Cursor := crSizeNESW;
    end;

    ghBL :
    begin
      Left := Control.Left - 2;
      Top := Control.Top + Control.Height - 3;
      Cursor := crSizeNESW;
    end;

    ghBR :
    begin
      Left := Control.Left + Control.Width - 3;
      Top := Control.Top + Control.Height - 3;
      Cursor := crSizeNWSE;
    end;
  end;
  FTargetCtrl := Control;
  Parent := Control.Parent;
  Visible := True;
end;

//  Ʈѿ ٽ  Ǵ.
procedure TGrabHandle.ReLock;
begin
  Lock(FTargetCtrl);
end;

procedure TGrabHandle.UnLock;
begin
  FTargetCtrl := nil;
  Parent := nil;
end;

(*----------------------------------------------------------------------------*)

(*----------------------------------------------------------------------------*)
//   Ŭ..
(*----------------------------------------------------------------------------*)

//   Ŭ.
procedure TForm2.NewWndProc( var Message: TMessage );
var
  Pt          : TPoint;
  TempControl : TControl;
begin
  with Message do
  begin
    Case Msg of
      WM_LBUTTONDBLCLK :
      begin
        Pt := Point(LoWord(lParam), HiWord(lParam));
        TempControl := nil;

        TempControl := Form1.ControlAtPos(Pt, True, False);

        if TempControl = nil then
          TempControl := Form1
        else
          Pt := TempControl.ScreenToClient(Form1.ClientToScreen(Pt));

        Perform(
          WM_USER+19126,
          Cardinal(Pointer(@TempControl)),
          Cardinal(Pointer(@Pt))
        );
        TempControl := nil;
        Exit;
      end;

      WM_LBUTTONDOWN :
      begin
        Pt := Point(LoWord(lParam), HiWord(lParam));
        TempControl := nil;

        TempControl := Form1.ControlAtPos(Pt, True, False);

        if TempControl = nil then
          TempControl := Form1
        else
          Pt := TempControl.ScreenToClient(Form1.ClientToScreen(Pt));

        Perform(
          WM_USER+19127,
          Cardinal(Pointer(@TempControl)),
          Cardinal(Pointer(@Pt))
        );

        TempControl := nil;
        Exit;
      end;

      WM_MOUSEMOVE : Perform(WM_USER+19128, Cardinal(wParam and MK_LBUTTON <> 0), 0);

      WM_LBUTTONUP :
      begin
        Perform(WM_USER+19129, 0, 0);
        ClipCursor(nil);
      end;

      WM_ERASEBKGND : Exit;

      WM_KEYDOWN :
      begin
        PostMessage(Handle, WM_USER+19125, wParam, lParam);
        Exit;
      end;
    end;

    Result := CallWindowProc(FOldProc, Form1.Handle, Msg, WParam, LParam);

  end;
end;
(*----------------------------------------------------------------------------*)

(*----------------------------------------------------------------------------*)
// TForm2  ̺Ʈ..  ޽ Ʈ.
(*----------------------------------------------------------------------------*)

// Ʈѿ Ű  ...
procedure TForm2.OnWMUser19125(var Message: TMessage);
var
  LV, TV, WV, HV : Integer;
  i : Integer;

  // Ʈѷκ ֻ Ʈѱ ܰ踦 ϴ .
  procedure CheckParentDepth(Control : TControl; var Depth : Integer);
  begin
    if (Control.Parent <> nil) then
    begin
      Inc(Depth);
      CheckParentDepth(Control.Parent, Depth);
    end;
  end;

  // õ Ʈ ... Ű    ֻ Ʈ  
  // θ ٸ ѵ û´   Ѵ.
  procedure ArrangeSelectForKey;
  var
    i : Integer;
    Depth, MaxDepth : Integer;
    Control : TControl;
  begin
    Control := nil;
    MaxDepth := 0;
    for i:= 0 to Form1.ComponentCount -1 do
      if Form1.Components[i] is TControl then
        if Boolean(TControl(Form1.Components[i]).Perform(WM_USER+19131, $AAAA, 0)) then
        begin
          Depth := 0;
          CheckParentDepth(TControl(Form1.Components[i]), Depth);
          if Depth > MaxDepth then
            Control := TControl(Form1.Components[i])
        end;

    if Control <> nil then
    for i:= 0 to Form1.ComponentCount -1 do
      if Form1.Components[i] is TControl then
        if TControl(Form1.Components[i]).Parent <> Control.Parent then
          TControl(Form1.Components[i]).Perform(WM_USER+19131, $BBBB, Cardinal(False));
  end;

  // ESCŰ   ó..
  procedure ArrangeSelectForESCKey;
  var
    i : Integer;
    Depth, MaxDepth : Integer;
    Control : TControl;
  begin
    if SelCtrlIsOver2 then
    begin
      Control := nil;
      MaxDepth := 0;
      for i:= 0 to Form1.ComponentCount -1 do
        if Form1.Components[i] is TControl then
          if Boolean(TControl(Form1.Components[i]).Perform(WM_USER+19131, $AAAA, 0)) then
          begin
            Depth := 0;
            CheckParentDepth(TControl(Form1.Components[i]), Depth);
            if Depth > MaxDepth then
              Control := TControl(Form1.Components[i]);
            TControl(Form1.Components[i]).Perform(WM_USER+19131, $BBBB, Cardinal(False));
          end;
      if (Control <> nil) and (Control.Parent <> Form1) then
        MSelectControl := Control.Parent;
    end else
    if (MSelectControl <> nil) then
    begin
      if (MSelectControl.Parent = Form1) then
        MSelectControl := nil
      else
        MSelectControl := MSelectControl.Parent;
    end;
  end;


begin
  inherited;
  LV := 0; TV := 0; WV := 0; HV := 0;

  with Message do
  if wParam = VK_ESCAPE then
  begin
    ArrangeSelectForESCKey;

    GrabHandleTT.UnLock;
    GrabHandleBB.UnLock;
    GrabHandleLL.UnLock;
    GrabHandleRR.UnLock;

    GrabHandleTL.UnLock;
    GrabHandleTR.UnLock;
    GrabHandleBL.UnLock;
    GrabHandleBR.UnLock;

    GrabHandleTT.Lock(MSelectControl);
    GrabHandleBB.Lock(MSelectControl);
    GrabHandleLL.Lock(MSelectControl);
    GrabHandleRR.Lock(MSelectControl);

    GrabHandleTL.Lock(MSelectControl);
    GrabHandleTR.Lock(MSelectControl);
    GrabHandleBL.Lock(MSelectControl);
    GrabHandleBR.Lock(MSelectControl);

    Exit;
  end else
  if (ssCtrl in KeyDataToShiftState(lParam)) and
     (ssShift in KeyDataToShiftState(lParam)) then
    Case wParam of
      VK_LEFT  : LV := -SnapX;
      VK_UP    : TV := -SnapY;
      VK_RIGHT : LV := SnapX;
      VK_DOWN  : TV := SnapY;
    else
      Exit;
    end
  else
  if ssCtrl in KeyDataToShiftState(lParam) then
    Case wParam of
      VK_LEFT  : LV := -1;
      VK_UP    : TV := -1;
      VK_RIGHT : LV := 1;
      VK_DOWN  : TV := 1;
    else
      Exit;
    end
  else
  if ssShift in KeyDataToShiftState(lParam) then
    Case wParam of
      VK_LEFT  : WV := -1;
      VK_UP    : HV := -1;
      VK_RIGHT : WV := 1;
      VK_DOWN  : HV := 1;
    else
      Exit;
    end
  else Exit;

  if MSelectControl <> nil then
  begin
    MSelectControl.SetBounds(
      MSelectControl.Left   + LV,
      MSelectControl.Top    + TV,
      MSelectControl.Width  + WV,
      MSelectControl.Height + HV
    );
  end else
  begin
    ArrangeSelectForKey;
    for i:= 0 to GrabSubClassList.Count -1 do
      if TGrabSubClass(GrabSubClassList.Objects[i]).Selected then
      begin
        TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect :=
          Bounds(
            TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect.Left + LV,
            TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect.Top + TV,
            TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect.Right -
            TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect.Left + WV,
            TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect.Bottom -
            TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect.Top + HV
          );
      end;
  end;
end;

// Ʈ Ŭ...
procedure TForm2.OnWMUser19126(var Message: TMessage);
var
  b : Boolean;
begin
  inherited;
  if ListBox1.Items.Count > 20 then ListBox1.Clear;
  ListBox1.Items.Add(
    Format('Ŭ %s, %d, %d', [
      TControl(Pointer(Message.wParam)^).Name,
      TPoint(Pointer(Message.lParam)^).X,
      TPoint(Pointer(Message.lParam)^).Y
    ])
  );
  ListBox1.ItemIndex := ListBox1.Items.Count -1;

  // Ʈ Ű   Ŭÿ ׸۸ .
  {---------------------------------------------------------------------}
  if GetKeyState(VK_SHIFT)<0 then
  begin
    ShiftMouseDowned := True;

    GrabHandleTT.UnLock;
    GrabHandleBB.UnLock;
    GrabHandleLL.UnLock;
    GrabHandleRR.UnLock;

    GrabHandleTL.UnLock;
    GrabHandleTR.UnLock;
    GrabHandleBL.UnLock;
    GrabHandleBR.UnLock;

    if TControl(Pointer(Message.wParam)^) = Form1 then Exit;

    //   ġȯ.
    b := Boolean(TControl(Pointer(Message.wParam)^).Perform(WM_USER+19131, $AAAA, 0));
    b := not b;
    TControl(Pointer(Message.wParam)^).Perform(
      WM_USER+19131,
      $BBBB,
      Cardinal(b)
    );

    if MSelectControl <> TControl(Pointer(Message.wParam)^) then
    begin
      MSelectControl.Perform(
        WM_USER+19131,
        $BBBB,
        Cardinal(True)
      );
    end;

    MSelectControl := nil;

    Exit;
  end;
  //  Ʈ Ű  ...
  {---------------------------------------------------------------------}

  OldRect  := TControl(Pointer(Message.wParam)^).BoundsRect;
end;

// ̷   ݵ ؾ ϴٴ... ... ư 콺    ׸
//  ϴ  ÷.
var
  RedrawRequire : Boolean = false;

// Ʈѿ 콺  .
procedure TForm2.OnWMUser19127(var Message: TMessage);
var
  i : Integer;
  b : Boolean;

  // õ Ʈ ... ̵   Ѱ θ ٸ  û¸
  // ش.
  procedure ArrangeSelect(Control : TControl);
  var
    i : Integer;
  begin
    for i:= 0 to Form1.ComponentCount -1 do
      if Form1.Components[i] is TControl then
        if TControl(Form1.Components[i]).Parent <> Control.Parent then
          TControl(Form1.Components[i]).Perform(WM_USER+19131, $BBBB, Cardinal(False));
  end;

begin
  inherited;
  if ListBox1.Items.Count > 20 then ListBox1.Clear;
  ListBox1.Items.Add(
    Format('콺ٿ %s, %d, %d', [
      TControl(Pointer(Message.wParam)^).Name,
      TPoint(Pointer(Message.lParam)^).X,
      TPoint(Pointer(Message.lParam)^).Y
    ])
  );
  ListBox1.ItemIndex := ListBox1.Items.Count -1;

  GrabHandleTT.UnLock;
  GrabHandleBB.UnLock;
  GrabHandleLL.UnLock;
  GrabHandleRR.UnLock;

  GrabHandleTL.UnLock;
  GrabHandleTR.UnLock;
  GrabHandleBL.UnLock;
  GrabHandleBR.UnLock;

  // Ʈ Ű  巡׷  ϴ 쿡 ϴ ƾ...
  {---------------------------------------------------------------------}
  if (GetKeyState(VK_CONTROL)<0) or (TControl(Pointer(Message.wParam)^) = Form1) then
  begin
    CtrlSelDowned := True;
    MSelectControl := TControl(Pointer(Message.wParam)^);

    // ̴  üũ..
    if csAcceptsControls in MSelectControl.ControlStyle then
    begin
      ClipControlCursor(TWinControl(MSelectControl));
      CtrlSelControl := TWinControl(MSelectControl);
    end
    else
    begin
      ClipControlCursor(MSelectControl.Parent);
      CtrlSelControl := MSelectControl.Parent;
    end;
    if (MSelectControl = CtrlSelControl) then MSelectControl := nil;
    //  õǾ ִ ༮  Ѵ.
    for i:= 0 to GrabSubClassList.Count -1 do
      TGrabSubClass(GrabSubClassList.Objects[i]).Selected := false;

    StartPos := CtrlSelControl.ScreenToClient(Mouse.CursorPos);
    OldPos   := Point(-10000, -10000);
    CtrlSelChanged := false;
    Exit;
  end;
  //  Ʈ ̿ 巡  .
  {---------------------------------------------------------------------}

  // Ʈ Ű   ϴ  ϴ ƾ...
  {---------------------------------------------------------------------}
  if GetKeyState(VK_SHIFT)<0 then
  begin
    ShiftMouseDowned := True;

    if TControl(Pointer(Message.wParam)^) = Form1 then Exit;

    //   ġȯ.
    b := Boolean(TControl(Pointer(Message.wParam)^).Perform(WM_USER+19131, $AAAA, 0));
    b := not b;
    TControl(Pointer(Message.wParam)^).Perform(
      WM_USER+19131,
      $BBBB,
      Cardinal(b)
    );

    //  õǾ ༮ Ѵ.
    if MSelectControl <> nil then
    if MSelectControl <> TControl(Pointer(Message.wParam)^) then
    begin
      MSelectControl.Perform(
        WM_USER+19131,
        $BBBB,
        Cardinal(True)
      );
    end;

    MSelectControl := nil;

    Exit;
  end;
  //  Ʈ Ű  ...
  {---------------------------------------------------------------------}

  //   ̻ õǾ ְ ٽ   õ ̸... Ƽ.
  {---------------------------------------------------------------------}
  MultiSelControl := TControl(Pointer(Message.wParam)^);

  if MultiSelControl = nil then Exit;
  b := Boolean(MultiSelControl.Perform(WM_USER+19131, $AAAA, 0));
  ArrangeSelect(MultiSelControl);
  if b and SelCtrlIsOver2 then
  begin
    MultiSelDowned := True;
    StartPos := MultiSelControl.Parent.ScreenToClient(Mouse.CursorPos);
    ClipControlCursor(MultiSelControl.Parent);
    OldPos   := MultiSelControl.Parent.ScreenToClient(Mouse.CursorPos);//Point(-10000, -10000);
    MultiSelChanged := false;
    Exit;
  end;
  //  Ƽ .
  {---------------------------------------------------------------------}

  //   Ʈ   ϴ ƾ..
  {---------------------------------------------------------------------}
  MSelectControl := TControl(Pointer(Message.wParam)^);

  if (MSelectControl = Form1) or (MSelectControl = nil) then
  begin
    for i:= 0 to GrabSubClassList.Count -1 do
      TGrabSubClass(GrabSubClassList.Objects[i]).Selected := false;
    MSelectControl := nil;
    Exit;
  end;

  MouseDowned := True;

  for i:= 0 to GrabSubClassList.Count -1 do
    TGrabSubClass(GrabSubClassList.Objects[i]).Selected := false;

  // ϳ   ó..
  OldRect  := MSelectControl.BoundsRect;
  StartPos := MSelectControl.Parent.ScreenToClient(Mouse.CursorPos);
  ClipControlCursor(MSelectControl.Parent);
  Form1.Update;

  // 簢 ׸.
  RectToCtrl(
    MSelectControl.Parent,
    Rect(OldRect.Left +1, OldRect.Top +1, OldRect.Right, OldRect.Bottom),
    2,
    psSolid
  );
  RedrawRequire := True;
  //    Ʈѿ..
  {---------------------------------------------------------------------}

end;

// 콺  .
procedure TForm2.OnWMUser19128(var Message: TMessage);
var
  Pt : TPoint;
  Rt : TRect;
  i : Integer;
begin
  inherited;

  // Ʈѷ ̴  ó.
  if CtrlSelDowned then
  begin
    //  ̸ ׸  .
    if CtrlSelChanged then
    begin
      //  ׸ .
      RectToCtrl(
        CtrlSelControl,
        Rect(StartPos.X, StartPos.Y, OldPos.X, OldPos.Y),
        1,
        psDot
      );
    end else
      CtrlSelChanged := True;

    //  ׸ ׸.
    OldPos := CtrlSelControl.ScreenToClient(Mouse.CursorPos);

    RectToCtrl(
      CtrlSelControl,
      Rect(StartPos.X, StartPos.Y, OldPos.X, OldPos.Y),
      1,
      psDot
    );

    Exit;
  end;

  //  Ʈѵ ̵ ó.
  if MultiSelDowned then
  begin
    Pt := MultiSelControl.Parent.ScreenToClient(Mouse.CursorPos);
    if (StartPos.X - Pt.X) mod SnapX <> 0 then Pt.X := Pt.X + (StartPos.X - Pt.X) mod SnapX;
    if (StartPos.Y - Pt.Y) mod SnapY <> 0 then Pt.Y := Pt.Y + (StartPos.Y - Pt.Y) mod SnapY;
    if ((OldPos.X = Pt.X) and (OldPos.Y = Pt.Y)) then Exit;

    if MultiSelChanged then
    //  ׸ ...
    for i:= 0 to GrabSubClassList.Count -1 do
      if TGrabSubClass(GrabSubClassList.Objects[i]).Selected then
      begin
        Rt := TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect;

        SetRect(Rt,
          Rt.Left   - (StartPos.X - OldPos.X),
          Rt.Top    - (StartPos.Y - OldPos.Y),
          Rt.Right  - (StartPos.X - OldPos.X),
          Rt.Bottom - (StartPos.Y - OldPos.Y)
        );

        RectToCtrl(
          MultiSelControl.Parent,
          Rect(Rt.Left +1, Rt.Top +1, Rt.Right, Rt.Bottom),
          2,
          psSolid
        );
      end;

    OldPos.X := Pt.X;
    OldPos.Y := Pt.Y;///

    if (OldPos.X = StartPos.X) and (OldPos.Y = StartPos.Y) then
    begin
      MultiSelChanged := false;
      Exit;
    end;

    MultiSelChanged := True;
    //  ׸ ׸..
    for i:= 0 to GrabSubClassList.Count -1 do
      if TGrabSubClass(GrabSubClassList.Objects[i]).Selected then
      begin
        Rt := TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect;

        SetRect(Rt,
          Rt.Left   - (StartPos.X - OldPos.X),
          Rt.Top    - (StartPos.Y - OldPos.Y),
          Rt.Right  - (StartPos.X - OldPos.X),
          Rt.Bottom - (StartPos.Y - OldPos.Y)
        );

        RectToCtrl(
          MultiSelControl.Parent,
          Rect(Rt.Left +1, Rt.Top +1, Rt.Right, Rt.Bottom),
          2,
          psSolid
        );
      end;
    Exit;
  end;

  //   Ʈѵ ̵ ó.
  if MouseDowned then
  begin
    //if not Boolean(Message.wParam) then Exit; // 콺 ̵ LButton  ..
    if (MSelectControl <> nil) and (MSelectControl <> Form1) then
    begin
      Pt := MSelectControl.Parent.ScreenToClient(Mouse.CursorPos);

      if (StartPos.X - Pt.X) mod SnapX <> 0 then Pt.X := Pt.X + (StartPos.X - Pt.X) mod SnapX;
      if (StartPos.Y - Pt.Y) mod SnapY <> 0 then Pt.Y := Pt.Y + (StartPos.Y - Pt.Y) mod SnapY;
      if (StartPos.X = Pt.X) and (StartPos.Y = Pt.Y) then Exit;

      //  ׸ ...
      RectToCtrl(
        MSelectControl.Parent,
        Rect(OldRect.Left +1, OldRect.Top +1, OldRect.Right, OldRect.Bottom),
        2,
        psSolid
      );

      // ġ ..
      OldRect :=
        Rect(
          OldRect.Left - (StartPos.X - Pt.X),
          OldRect.Top - (StartPos.Y - Pt.Y),
          OldRect.Right - (StartPos.X - Pt.X),
          OldRect.Bottom - (StartPos.Y - Pt.Y)
        );
      StartPos.X := Pt.X;
      StartPos.Y := Pt.Y;

      //  ׸ ׸.
      RectToCtrl(
        MSelectControl.Parent,
        Rect(OldRect.Left +1, OldRect.Top +1, OldRect.Right, OldRect.Bottom),
        2,
        psSolid
      );
    end;
  end;
end;

// 콺  ...
procedure TForm2.OnWMUser19129(var Message: TMessage);
var
  i, Int : Integer;
  Rt, Rt2 : TRect;
  B : Boolean;
begin
  inherited;
  if ListBox1.Items.Count > 20 then ListBox1.Clear;
  ListBox1.Items.Add('콺 ');
  ListBox1.ItemIndex := ListBox1.Items.Count -1;

  // Ʈ Ű ̿   ..
  if CtrlSelDowned then
  begin
    CtrlSelDowned := false;

    // Ʈ  ¿ ٸ...
    if CtrlSelChanged then
    begin
      // ׸ .
      RectToCtrl(
        CtrlSelControl,
        Rect(StartPos.X, StartPos.Y, OldPos.X, OldPos.Y),
        1,
        psDot
      );

      for i:= 0 to CtrlSelControl.ControlCount -1 do
      begin
        Rt2 := Rect(StartPos.X, StartPos.Y, OldPos.X, OldPos.Y);

        if Rt2.Left > Rt2.Right then // ¿ ǥ ٲ  ̹Ƿ...
        begin
          Int := Rt2.Left;
          Rt2.Left := Rt2.Right;
          Rt2.Right := Int;
        end;

        if Rt2.Top > Rt2.Bottom then //  ǥ ٲ  ̹Ƿ...
        begin
          Int := Rt2.Top;
          Rt2.Top := Rt2.Bottom;
          Rt2.Bottom := Int;
        end;

        // ܰ ġ .
        IntersectRect(Rt,
          CtrlSelControl.Controls[i].BoundsRect,
          Rt2
        );
        if not IsRectEmpty(Rt) then
          CtrlSelControl.Controls[i].Perform(WM_USER+19131, $BBBB, Cardinal(True));
      end;

      //   ̻ õ  MSelectControl  Nil ٲ ׸۸ .
      if SelCtrlIsOver2 then
        MSelectControl := Nil
      else
      // ׷     ʷ ɸ  MSelectControl Ѵ.
      for i:= 0 to CtrlSelControl.ControlCount -1 do
      begin
        B := Boolean(CtrlSelControl.Controls[i].Perform(WM_USER+19131, $AAAA, 0));
        CtrlSelControl.Controls[i].Perform(WM_USER+19131, $BBBB, Cardinal(false));
        if B then
        begin
          MSelectControl := CtrlSelControl.Controls[i];
          Break;
        end;
      end;
    end;

    if MSelectControl = nil then
    begin
      // õ  ٴ ȴ...
    end else
    begin
      GrabHandleTT.Lock(MSelectControl);
      GrabHandleBB.Lock(MSelectControl);
      GrabHandleLL.Lock(MSelectControl);
      GrabHandleRR.Lock(MSelectControl);

      GrabHandleTL.Lock(MSelectControl);
      GrabHandleTR.Lock(MSelectControl);
      GrabHandleBL.Lock(MSelectControl);
      GrabHandleBR.Lock(MSelectControl);
    end;

    CtrlSelChanged := false;
    CtrlSelControl := nil;
    Exit;
  end;

  //  Ʈ  Ű .
  if MultiSelDowned then
  begin
    // ǥ ȭ ִ 쿡...
    if MultiSelChanged then
    // ȭ ׸ , Ʈѵ ġ Ѵ.
    for i:= 0 to GrabSubClassList.Count -1 do
      if TGrabSubClass(GrabSubClassList.Objects[i]).Selected then
      begin
        Rt := TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect;

        SetRect(Rt,
          Rt.Left   - (StartPos.X - OldPos.X),
          Rt.Top    - (StartPos.Y - OldPos.Y),
          Rt.Right  - (StartPos.X - OldPos.X),
          Rt.Bottom - (StartPos.Y - OldPos.Y)
        );

        RectToCtrl(
          MultiSelControl.Parent,
          Rect(Rt.Left +1, Rt.Top +1, Rt.Right, Rt.Bottom),
          2,
          psSolid
        );
      end;

    if MultiSelChanged then
    for i:= 0 to GrabSubClassList.Count -1 do
      if TGrabSubClass(GrabSubClassList.Objects[i]).Selected then
      begin
        Rt := TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect;

        SetRect(Rt,
          Rt.Left   - (StartPos.X - OldPos.X),
          Rt.Top    - (StartPos.Y - OldPos.Y),
          Rt.Right  - (StartPos.X - OldPos.X),
          Rt.Bottom - (StartPos.Y - OldPos.Y)
        );

        TGrabSubClass(GrabSubClassList.Objects[i]).BoundsRect := Rt;
      end;

    MultiSelDowned  := false;
    MultiSelChanged := false;
    MultiSelControl := nil;
    Exit;
  end;

  // Ʈ Ű   Ʈ  .
  if ShiftMouseDowned then
  begin
    ShiftMouseDowned := false;

    GrabHandleTT.Lock(MSelectControl);
    GrabHandleBB.Lock(MSelectControl);
    GrabHandleLL.Lock(MSelectControl);
    GrabHandleRR.Lock(MSelectControl);

    GrabHandleTL.Lock(MSelectControl);
    GrabHandleTR.Lock(MSelectControl);
    GrabHandleBL.Lock(MSelectControl);
    GrabHandleBR.Lock(MSelectControl);
    Exit;
  end;

  //   Ʈ ġ  .
  if MouseDowned then
  begin
    MouseDowned := false;
    if (MSelectControl <> nil) and (MSelectControl <> Form1) then
    begin
      if RedrawRequire then
      begin
        // 簢 .
        RectToCtrl(
          MSelectControl.Parent,
          Rect(OldRect.Left +1, OldRect.Top +1, OldRect.Right, OldRect.Bottom),
          2,
          psSolid
        );
        RedrawRequire := false;
      end;

      // ġ...
      MSelectControl.SetBounds(
        OldRect.Left, OldRect.Top,
        OldRect.Right - OldRect.Left,
        OldRect.Bottom - OldRect.Top
      );

      GrabHandleTT.Lock(MSelectControl);
      GrabHandleBB.Lock(MSelectControl);
      GrabHandleLL.Lock(MSelectControl);
      GrabHandleRR.Lock(MSelectControl);

      GrabHandleTL.Lock(MSelectControl);
      GrabHandleTR.Lock(MSelectControl);
      GrabHandleBL.Lock(MSelectControl);
      GrabHandleBR.Lock(MSelectControl);

      SetRect(OldRect, -10000, -10000, 0, 0);
    end;
  end;
end;

procedure TForm2.OnWMUser19130(var Message: TMessage);
begin
  inherited;
  Case Message.wParam of
    // Ʈ ġ   ٲ  ƿ ޽.
    // Ǵ ׸۸ Ŭ  ƿ ޽.
    $AAAA :
    begin
      GrabHandleTT.ReLock;
      GrabHandleBB.ReLock;
      GrabHandleLL.ReLock;
      GrabHandleRR.ReLock;

      GrabHandleTL.ReLock;
      GrabHandleTR.ReLock;
      GrabHandleBL.ReLock;
      GrabHandleBR.ReLock;
    end;

    $BBBB :
    begin
      GrabHandleTT.Visible := False;
      GrabHandleBB.Visible := False;
      GrabHandleLL.Visible := False;
      GrabHandleRR.Visible := False;

      GrabHandleTL.Visible := False;
      GrabHandleTR.Visible := False;
      GrabHandleBL.Visible := False;
      GrabHandleBR.Visible := False;
      Form1.Update;
    end;
  end;
end;

//  Ʈ ̺Ʈ.
procedure TForm2.FormPaint(Sender: TObject);
var
  BackBmp : TBitmap;
begin
  BackBmp := TBitmap.Create;
  try
    BackBmp.Width := SnapX;
    BackBmp.Height := SnapY;
    BackBmp.Canvas.Brush.Color := Form1.Color;
    BackBmp.Canvas.FillRect(Bounds(0, 0, BackBmp.Width, BackBmp.Height));
    BackBmp.Canvas.Pen.Mode := pmNotXor;
    //BackBmp.Canvas.Pen.Color := ;
    BackBmp.Canvas.Pixels[0, 0] := PaletteRGB($31, $27, $00);
    TForm(Sender).Canvas.Brush.Color := Form1.Color;
    TForm(Sender).Canvas.Brush.Bitmap := BackBmp;
    //TForm(Sender).Canvas.CopyMode := cmSrcInvert;
    TForm(Sender).Canvas.FillRect(TForm(Sender).ClientRect);
  finally
    BackBmp.Free;
  end;
  if Assigned(FOldFormPaint) then FOldFormPaint(Sender);
end;

function TForm2.SelCtrlIsOver2 : Boolean;
var
  i, j : Integer;
begin
  Result := False;
  j := 0;
  for i:= 0 to GrabSubClassList.Count -1 do
    if TGrabSubClass(GrabSubClassList.Objects[i]).Selected then
    begin
      Inc(j);
      if j > 1 then
      begin
        Result := True;
        Break;
      end;
    end;
end;

procedure TForm2.FormCreate(Sender: TObject);
var
  i : Integer;
  GrabSubClass : TGrabSubClass;
begin
  // Ŭ Ǵ.
  FOldProc := Pointer(GetWindowLong(Form1.Handle, GWL_WNDPROC));
  FNewProc := MakeObjectInstance(NewWndProc);
  SetWindowLong(Form1.Handle, GWL_WNDPROC, LongInt(FNewProc));

  GrabSubClassList := TStringList.Create;
  for i:= 0 to Form1.ComponentCount -1 do
  if Form1.Components[i] is TControl then
  begin
    GrabSubClass := TGrabSubClass.Create(TControl(Form1.Components[i]), Handle);
    GrabSubClassList.AddObject('', GrabSubClass);
  end;

  GrabHandleTT := TGrabHandle.Create(nil);
  GrabHandleBB := TGrabHandle.Create(nil);
  GrabHandleLL := TGrabHandle.Create(nil);
  GrabHandleRR := TGrabHandle.Create(nil);

  GrabHandleTR := TGrabHandle.Create(nil);
  GrabHandleTL := TGrabHandle.Create(nil);
  GrabHandleBR := TGrabHandle.Create(nil);
  GrabHandleBL := TGrabHandle.Create(nil);

  GrabHandleTT.GHType := ghTT; GrabHandleTT.Tag := Handle;
  GrabHandleBB.GHType := ghBB; GrabHandleBB.Tag := Handle;
  GrabHandleLL.GHType := ghLL; GrabHandleLL.Tag := Handle;
  GrabHandleRR.GHType := ghRR; GrabHandleRR.Tag := Handle;

  GrabHandleTR.GHType := ghTR; GrabHandleTR.Tag := Handle;
  GrabHandleTL.GHType := ghTL; GrabHandleTL.Tag := Handle;
  GrabHandleBR.GHType := ghBR; GrabHandleBR.Tag := Handle;
  GrabHandleBL.GHType := ghBL; GrabHandleBL.Tag := Handle;

  // Ʈ ̺Ʈ ġ.
  FOldFormPaint := Form1.OnPaint;
  Form1.OnPaint := FormPaint;

end;

procedure TForm2.FormDestroy(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to GrabSubClassList.Count -1 do
    TGrabSubClass(GrabSubClassList.Objects[i]).Free;

  GrabSubClassList.Clear;
  GrabSubClassList.Free;

  GrabHandleTT.Free;
  GrabHandleBB.Free;
  GrabHandleLL.Free;
  GrabHandleRR.Free;

  GrabHandleTR.Free;
  GrabHandleTL.Free;
  GrabHandleBR.Free;
  GrabHandleBL.Free;

  //  Ŭ .
  SetWindowLong(Form1.Handle, GWL_WNDPROC, LongInt(FOldProc));
  FreeObjectInstance (FNewProc);

  //  ̺Ʈ 
  Form1.OnPaint := FOldFormPaint;
//  Application.MessageBox('ҳ  ̺귯 1ź.  " ̳ʰ ~"   '+#10+'̿ ּż մϴ~ ~'+#10+''+#10+'2000. 2. 24. ҳ Ʈ', 'About... TestVersion...', MB_OK+MB_ICONASTERISK+MB_DEFBUTTON1+MB_APPLMODAL);
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  if Assigned(MSelectControl) then
    MSelectControl.Width := 100;
//
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  if Assigned(MSelectControl) then
    TForm(MSelectControl).Font.Size := 20;
//
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  if Form1.Menu <> nil then
    Form1.Menu := nil
  else
    Form1.Menu := Form1.MainMenu1;
//
end;

procedure TForm2.Button4Click(Sender: TObject);
begin
  if MSelectControl <> nil then
    MSelectControl.BringToFront;
//
end;

procedure TForm2.Button5Click(Sender: TObject);
var
  i : Integer;
begin
  GrabHandleTT.UnLock;
  GrabHandleBB.UnLock;
  GrabHandleLL.UnLock;
  GrabHandleRR.UnLock;

  GrabHandleTL.UnLock;
  GrabHandleTR.UnLock;
  GrabHandleBL.UnLock;
  GrabHandleBR.UnLock;

  if MSelectControl <> nil then
  begin
    MSelectControl.Perform(WM_USER+19131, $BBBB, Cardinal(True));
    MSelectControl := nil;
  end;

  for i:= 0 to GrabSubClassList.Count -1 do
  begin
    TGrabSubClass(GrabSubClassList.Objects[i]).Selected :=
      not TGrabSubClass(GrabSubClassList.Objects[i]).Selected;
  end;
end;

procedure TForm2.Button6Click(Sender: TObject);
begin
  ShowMessage(IntToStr(Application.ComponentCount));
end;

end.


